#region licence/info

//////project name
//2d gui nodes

//////description
//nodes to build 2d guis in a EX9 renderer

//////licence
//GNU Lesser General Public License (LGPL)
//english: http://www.gnu.org/licenses/lgpl.html
//german: http://www.gnu.de/lgpl-ger.html

//////language/ide
//C# sharpdevelop 

//////dependencies
//VVVV.PluginInterfaces.V1;
//VVVV.Utils.VMath;

//////initial author
//tonfilm

#endregion licence/info

using System;
using VVVV.Utils.VMath;
using VVVV.Utils.VColor;
using VVVV.Nodes.src.Controllers;

namespace VVVV.Nodes
{
	//parent class for controllers
	public class AbstractMTGui2dController
	{
		public Matrix4x4 Transform;
		public Matrix4x4 InvTransform;
		public bool Hit;
		public bool Active;
        public Touch AssignedTouch;
        public Touch LastTouchPos;
        public bool NewHit;

        public AbstractMTGui2dController()
		{
			Transform = VMath.IdentityMatrix;
			InvTransform = VMath.IdentityMatrix;
			Active = false;
			Hit = false;
            AssignedTouch = null;
            LastTouchPos = null;
            NewHit = false;

		}

        public virtual void CopyFrom(AbstractMTGui2dController Source)
		{
			Transform = Source.Transform;
			InvTransform = Source.InvTransform;
			Active = Source.Active;
			Hit = Source.Hit;
            AssignedTouch = null;
            LastTouchPos = null;
            NewHit = false;
		}
		
	}
}
